import { ViewBase } from '../../libappbase/viewbase';
import { AppMP } from '../appmp';
import { FormScenario } from '../forms/form.scenario';
import { UIWaitSOP } from '../../libappsop/objectsop';
import { FormKPIMatrix } from '../forms/form.kpimatrix';

/**
 * Scenario Analysis > Overview
 */
export class ViewScenarioAnalysisOverview extends ViewBase implements UIWaitSOP {
  public readonly name = 'Scenarios';
  public readonly viewPath = 'Scenario Analysis > Overview';

  public formScenario = new FormScenario();
  public formKPIMatrix = new FormKPIMatrix();

  /**
   * Switch to Scenario Analysis > Overview View
   */
  public async switchTo(): Promise<void> {
    const appMP = AppMP.getInstance();
    // Click Scenario Analysis action bar page
    await appMP.abpScenarioAnalysis.click();
    // Click open Overview view
    await appMP.abpScenarioAnalysis.btnOverview.click();
    await this.waitUILoaded();
    }

  public async waitUILoaded(): Promise<void> {
    await this.formScenario.waitUntilPresent();
  }
}
